"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.router = exports.Router = void 0;
class Router {
    constructor(options) {
        this.options = options;
    }
    get router() {
        var _a, _b;
        if (this._router)
            return this._router;
        if ((_a = this.options) === null || _a === void 0 ? void 0 : _a.router) {
            this._router = (_b = this.options) === null || _b === void 0 ? void 0 : _b.router;
        }
        else if (window.__doreamonjs.has('router')) {
            // doreamonjs
            this._router = window.__doreamonjs.get('router');
        }
        else {
            throw new Error('[doreamonjs] router is not registered');
        }
        return this._router;
    }
    push(path, state) {
        this.router.push(path, state);
    }
    replace(path, state) {
        this.router.replace(path, state);
    }
    go(count) {
        this.router.go(count);
    }
    goBack() {
        this.router.goBack();
    }
}
exports.Router = Router;
exports.router = new Router();
